stages:
  - test
  - build
  - release

include:
  - project: vigigloo/gitlab-pipeline-fragments
    ref: v1
    file:
      - registry/terraform.yml
      - registry/helm.auto.yml

.vigigloo:terraform:
  image:
    name: hashicorp/terraform:1.5

vigigloo:
  stage: .pre
  image:
    name: registry.gitlab.com/vigigloo/cli:dslim-v1.4.0
    entrypoint: [""]
  script:
    - vigigloo assist
  artifacts:
    paths:
      - terraform_module_cluster
      - terraform_module_controller

registry:helm:init:
  parallel:
    matrix:
      - HELM_CHART_NAME: cloudnative-pg-cluster
        HELM_CHART_PATH: ./helm_chart_cluster
        HELM_OUT_DIRECTORY: ./out/helm_cluster

registry:helm:lint:
  parallel: !reference [registry:helm:init, parallel]

registry:helm:build:
  parallel: !reference [registry:helm:init, parallel]

registry:helm:upload:
  parallel: !reference [registry:helm:init, parallel]

registry:terraform:init:
  extends: .vigigloo:registry:terraform:init
  interruptible: true
  stage: .pre
  parallel:
    matrix:
      - TERRAFORM_REGISTRY_MODULE_NAME: tools-k8s-cloudnativepg
        TERRAFORM_REGISTRY_SYSTEM_NAME: controller
        TERRAFORM_REGISTRY_MODULE_PATH: ./terraform_module_controller
        TERRAFORM_OUT_DIRECTORY: ./out/terraform_controller
      - TERRAFORM_REGISTRY_MODULE_NAME: tools-k8s-cloudnativepg
        TERRAFORM_REGISTRY_SYSTEM_NAME: cluster
        TERRAFORM_REGISTRY_MODULE_PATH: ./terraform_module_cluster
        TERRAFORM_OUT_DIRECTORY: ./out/terraform_cluster
  needs:
    - job: vigigloo
      artifacts: true

registry:terraform:validate:
  extends: .vigigloo:registry:terraform:validate
  interruptible: true
  stage: test
  parallel: !reference [registry:terraform:init, parallel]

registry:terraform:build:
  extends: .vigigloo:registry:terraform:build
  stage: build
  parallel: !reference [registry:terraform:init, parallel]
  artifacts:
    paths:
      - out

registry:terraform:upload:
  extends: .vigigloo:registry:terraform:upload
  stage: release
  parallel: !reference [registry:terraform:init, parallel]
  needs:
    - job: registry:terraform:build
      artifacts: true
    - job: vigigloo
      artifacts: true
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
